<?php
/**
* Plugin Name: AI Content Detector
* Plugin URI: https://www.freedetector.ai/
* Description: It's A Free AI Content Plagiarism Checker Tool to Detect Content is Written By AI or Either by Humans.
* Version: 1.1
* Author: freedetector
* Author URI: https://github.com/ctrlsbackup/freedetector
* License: GPL2
*/
// Register and load the hooks
function init_content_detector()
{
	global $wpdb;
	$db_table_name = $wpdb->prefix . 'ai_content_detector';
  	$charset_collate = $wpdb->get_charset_collate();
	 //Check to see if the table exists already, if not, then create it
	 if($wpdb->get_var( "show tables like '$db_table_name'" ) != $db_table_name ) 
	 {
		   $sql = "CREATE TABLE `$db_table_name` (
					`id` int(11) NOT NULL auto_increment,
					`token` varchar(65) NOT NULL,
					UNIQUE KEY id (id)
			) $charset_collate;";
	
	   require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	   dbDelta( $sql );
	 }
}
function get_token()
{
	global $wpdb;
	global $aicd_db_version;
	$aicd_db_version = '1.1';
	$db_table_name = $wpdb->prefix . 'ai_content_detector';
	$url = "https://www.freedetector.ai/api/wp_generate_token";
	$aihost = home_url()."/";
	$headers = array(
	   "Accept: application/json",
	   "AIHost: $aihost"
	);
	$data = [
    'get_token' => true,
	];
	$curl = curl_init($url);
	curl_setopt($curl, CURLOPT_URL, $url);
	curl_setopt($curl, CURLOPT_POST, true);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
	$resp = json_decode(curl_exec($curl));
	curl_close($curl);
	$token = $resp->token;
	require_once( ABSPATH . 'wp-includes/option.php' );
 	if(get_option("aicd_db_version") == false)
	{
		$wpdb->insert($db_table_name, array('token' => $token));
		add_option( 'aicd_db_version', $aicd_db_version );
	}
	else
	{
		$wpdb->update($db_table_name, array('token' => $token),array('id'=>1));
	}
}
function custom_button_check_ai($post)
{
    // Show only for published pages.
   /* if ( ! $post
         || 'publish' !== $post->post_status
         || 'page' !== $post->post_type ) {
        return;
    }*/
	$wp_home_url = "'".home_url()."/'";
    $html = '<div id="major-publishing-actions" style="overflow:hidden">';
    $html .= '<div id="publishing-action" style="width:100%;text-align:center;">';
    $html .= '<input type="button" accesskey="p" tabindex="5" onclick="check_content_ai('.$wp_home_url.')" value="Check Content is AI or Not?" class="button-primary" id="submitbox-custom-button" name="publish">';
 	//$html .= '<div style="display:none;" id="ai_results">Result</div>';
	$html .= '<div class="progress" id="progress_main_id" style="display:none;width:92%;">
                <div class="progress-bar bg-success" id="progress_sub_ids" style=""></div>
                <div class="progress-bar bg-danger progress-bar-stripped" id="progress_sub_idf" style=""></div>
			</div><div id="loaderp" style="display:none;padding-top:6px;"><img src="'.plugin_dir_url( __FILE__ ).'images/loader.gif" width="30"/></div>';
    // Post meta example.
    /*$user = get_user_by( 'ID', get_post_meta( $post->ID, '_edit_last', true ) );
    if ( $user ) {
        $html .= '<div>' . ucfirst( $post->post_type ) . ' ' . $post->ID . ' last edited by ' . $user->display_name . '</div>';
    }*/
    $html .= '</div>';
    $html .= '</div>';
    // Customize button click event.
   /* $html .= "<script>window.addEventListener('load', function(){ jQuery('input#submitbox-custom-button').click(function(event){  event.preventDefault(); alert('You\'re editing " . $post->post_type . " " . $post->ID . "'); return true; }); });</script>";*/
    echo $html;
}
function ai_js_init() {
	wp_enqueue_script( 'ai-content-js', plugins_url( '/js/ai-content-function.js', __FILE__ ));
	wp_enqueue_style('ai-content-css', plugins_url('/css/ai_style.css',__FILE__ ));
}
register_activation_hook( __FILE__, 'init_content_detector' );
register_activation_hook( __FILE__, 'get_token' );
add_action( 'post_submitbox_misc_actions', 'custom_button_check_ai', 10, 1 );
add_action('admin_enqueue_scripts','ai_js_init');
function ai_content_register_route()
{
    register_rest_route('ai_content_route', 'plag_check', array(
        'methods' => 'POST',
        'callback' => 'custom_ai_routes',
            )
    );
}
function custom_ai_routes($request_data)
{
	global $wpdb;
	$db_table_name = $wpdb->prefix . 'ai_content_detector';
	$parameters = $request_data->get_params();
  	$inputs_text = str_replace(array("\r", "\n"), '', $parameters['inputs']);
	$url = "https://www.freedetector.ai/api/wp_detector";
	$data = json_encode( array( "text"=> $inputs_text ) );
	$row_token = $wpdb->get_row( "SELECT token FROM $db_table_name WHERE id = 1" );
	$token = $row_token->token;
	$aihost = home_url()."/";
	$headers = array(
	   "Accept: application/json",
	   "AIHost: $aihost",
	   "Authorization: $token"
	);
	$curl = curl_init($url);
	curl_setopt($curl, CURLOPT_URL, $url);
	curl_setopt($curl, CURLOPT_POST, true);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
	$resp = json_decode(curl_exec($curl));
	curl_close($curl);
    return rest_ensure_response($resp);
}
add_action('rest_api_init', 'ai_content_register_route');
?>